(define-module (librefinder i18n)
  #:use-module (srfi srfi-26)
  #:use-module (librefinder config)
  #:export (G_
            N_
            %gettext-domain
            init-locale))

(define %gettext-domain
  ;; Text domain for strings used in the tools.
  "guile-librefinder")

(define G_ (cut gettext <> %gettext-domain))
(define N_ (cut ngettext <> <> <> %gettext-domain))

(define (init-nls)
  "Bind this project's textdomain."
  (bindtextdomain %gettext-domain %localedir))

(define (init-locale)
  "Install the current locale settings."
  (catch 'system-error
         (lambda _ (setlocale LC_ALL ""))
         (lambda args
           (false-if-exception
             (setlocale LC_ALL "en_US.utf8"))))
  (init-nls)
  (textdomain %gettext-domain))
