(define-module (librefinder serialize)
  #:use-module ((librefinder trait) #:prefix lf:)
  #:use-module ((librefinder source) #:prefix lf:)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-180)
  #:export (source->json
	    trait->json
	    librefinder->json))

(define (librefinder->type val)
  (cond
   ((lf:source? val) lf:<source>)
   ((lf:trait? val) lf:<trait>)
   (else #f)))

(define (librefinder-type->sjson-writer val)
  (cond
      ((equal? lf:<source> val) source->sjson)
      ((equal? lf:<trait> val) trait->sjson)
      (else #f)))

(define (librefinder->sjson-writer val)
  (librefinder-type->sjson-writer (librefinder->type val)))

(define (description->sjson val)
  (apply format `(#f ,(car val) ,@(map librefinder->sjson (cdr val)))))

(define (source->sjson a)
  `((name . ,(lf:source-name a))
		,@(if (lf:source-page a)
		      `((page . ,(lf:source-page a)))
		      '())))

(define (trait->sjson a)
  `((type . "trait")
		(name . ,(lf:trait-name a))
		(source . ,(source->sjson (lf:trait-source a)))
		(description . ,(description->sjson (lf:trait-description a)))))

(define (librefinder->sjson a)
  (and=> (librefinder->sjson-writer a)
	 (lambda (w) (w a))))

(define (librefinder->json a)
  (json-write (librefinder->sjson a)))
