(define-module (librefinder source)
  #:use-module (guix records)
  #:use-module (librefinder i18n)
  #:use-module (librefinder utils)
  #:export (source
	    <source>
	    make-source
	    source?
	    source-name
	    source-page

	    sanitize-source))

(define (string?=> s)
  (if (string? s) s #f))

(define (exact-integer?=> n)
  (if (exact-integer? n) n #f))

(define (sanitize-?string-number n)
  (and=> n
	 (lambda (n)
	   (or
	    (and=>
	     (and=>
	      (and=> n string?=>)
	      string->number)
	     exact-integer?=>)
	    (throw 'bad! n)))))

(define-record-type* <source> source
  make-source
  source?
  this-source
  (name source-name
	(sanitize sanitize-string))
  (page source-page
	(default #f)
	(sanitize sanitize-?string-number)))

(make-sanitizer source)
