(define-module (librefinder trait)
  #:use-module (guix records)
  #:use-module (srfi srfi-1)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-180)
  #:use-module (librefinder utils)
  #:use-module (librefinder source)
  #:export (trait
	    <trait>
	    make-trait
	    trait?
	    traits?
	    trait-name
	    trait-source
	    trait-description

	    sanitize-trait
	    sanitize-traits))

(define (sanitize-description value)
  (match value
    ((? string?) (list value))
    (((? string?) _ ...) value)
    (#f #f)
    (_ (throw 'bad! value))))

(define-record-type* <trait> trait
  make-trait
  trait?
  this-trait
  (name trait-name
	(sanitize sanitize-string))
  (value trait-value
	 (default #f)
	 (sanitize sanitize-?number))
  (source trait-source
	  (sanitize sanitize-source))
  (description trait-description
	       (sanitize sanitize-description)))

(make-sanitizer trait)

(make-list-predicate trait)

(make-sanitizer traits)
